



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>POJ 2887 Big String （块状数组）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">POJ 2887 Big String （块状数组）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-20 21:56:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题意：给一个字符串（&lt;=1000000)和n个操作（&lt;2000），每个操作可以在某个位置插入一个字符，或者查询该位置的字符。问查询结果。</p>
<p>思路：块状数组。</p>
<p>如果将原来的字符串都存在一起，每次插入肯定会超时。</p>
<p>而操作数比较少，考虑使用分块法。假设原字符串长度为L，则取每块长度l=sqrt（L）。这样每次插入，我们需要用sqrt(L)的时间找到对应的块，再用sqrt(L)在该块进行插入。查询同样需要sqrt(L)找到该块，如果用数组实现可以O（1）找到目标元素。（我尝试用stl链表来做，结果超时了）</p>
<p>这样最坏的情况下，一个块最多有2000个字符，当然操作不会超时，但是数组要开得足够大。</p>
<div>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;
#include &lt;cstdio&gt;
#include &lt;cstring&gt;
#include &lt;algorithm&gt;
#include &lt;cmath&gt;
#include &lt;list&gt;
#define ll long long
using namespace std;
int Maxn, N ;
];
struct BlockList
{
    int size;
    ];
    int at(int pos)
    {
        return dat[pos];
    }
    void insert(int pos,char c)
    {
        ];
        dat[pos]=c;
    }
    void push_back(char c)
    {
        dat[++size]=c;
    }
};
BlockList block[];
char query(int s,int p)
{
    return block[s].at(p);
}
void insert(int s,int p,char c)
{
    p=min(p,block[s].size+);
    block[s].insert(p,c);
}
void maintain()
{
    ; i&lt;=Maxn; ++i)
        sum[i]=sum[i-]+block[i].size;
}
void MyInsert(int pos,char c)
{
    ,sum++Maxn,pos)-(sum);
    insert(p,pos-sum[p-],c);
    maintain();
}
int MyQuery(int pos)
{
    ,sum++Maxn,pos)-(sum);
    ]);
}
];
void init()
{
    int len=strlen(str)+N;
    Maxn=sqrt(len*;
    ; str[i]; ++i)
        block[i/Maxn+].push_back(str[i]);
    maintain();
}
int main()
{
    gets(str);
    int pos;
    ],s[];
    scanf("%d",&amp;N);
    init();
    while(N--)
    {
        scanf("%s",p);
        ]=='I')
        {
            scanf("%s%d",s,&amp;pos);
            MyInsert(pos,s[]);
        }
        else
        {
            scanf("%d",&amp;pos);
            printf("%c\n",MyQuery(pos));
        }
    }
    ;
}</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn1vzg8.html">jsTree简单应用Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z4dmn9.html">Bar菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93065r9.html">php--yii框架表单验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjxxyk9.html">swift 委托代理传值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv3voxq.html">Python 异常结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1rlde9.html">leetcode&commat; &lbrack;174&rsqb; Dungeon Game &lpar;Dynamic Programming&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mv52jq.html">jQuery提供的小方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mngmkoq.html">Android 绘图工具库AChartEngine</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz0z5g8.html">Windows Azure入门教学系列 &lpar;二&rpar;：部署第一个Web Role程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwo1jq.html">3&period; SQL Server数据库状态监控 - 可用空间</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ydg7n8.html">UVa 459 - Graph Connectivity</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjlrjg8.html">while循环写3次用户名密码验证程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkr02e8.html">温故而知新-set</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j460v8.html">linux的dd命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk74ed8.html">linux 端口占用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95062om8.html">1、在Centos上安装Grafana</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwvd48.html">python之psutil模块&lpar;获取系统性能数据&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95grpwvq.html">20165306 Exp3 免杀原理与实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdwm0j9.html">四、Linux的常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/960eld39.html">2&period;22 JS处理富文本</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j00xv4q.html">SAP MM移动平均价和标准价逻辑</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rddmy48.html">Spring表达式语言 之 5&period;3 SpEL语法（拾肆）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmm20e9.html">web 页面内容优化管理与性能技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wwe2lq.html">Qt之Concurrent Map和Map-Reduce</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdee1lv9.html">zju 1091</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjj5779.html">emmet使用笔记及sublime常用快捷键</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnn4z6q.html">kwicks插件学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmm3269.html">BOM组件物料重复检查</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e11gyz9.html">Objective-C：Foundation框架-常用类-NSMutableArray</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvvljyq.html">BZOJ3057 圣主的考验</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
